﻿$(document).ready(function() {
	loadCommentsFromStorage();
	loadAllLikes();

	$("#addComment").click(function() {
		try {
		var commentText = $("#field_msg").val();
		
		var newId = "new-comment-item-" + getCounter();
		$("#new-comment-item").clone().css("display", "").attr("id", newId).appendTo("#comments-list");
		
		$("#" + newId + " .divComment").html(commentText);
		$("#" + newId + " .divDate").html(getFormattedDate());
		
		$("#field_msg").val("");

		addCommentToStorage(commentText, getFormattedDate());

		$('#field_msg').first().focus();

		} catch(e) {console.log(e);}
	});

	$("#comments-list").on("click", ".widget-list_i", function() {
		if($(this).hasClass("no-like-block")) {
			$(this).html($("#like_block").html());
			$(this).addClass("like-block").removeClass("no-like-block");
			saveAllLikes();
			return;
		}
		if($(this).hasClass("like-block")) {
			$(this).html($("#unlike_block").html());
			$(this).addClass("no-like-block").removeClass("like-block");
			saveAllLikes();
			return;
		}
	});
	
	bindMainLikeButton();
	
	$(".cmntLink").click(function() {
		$('#field_msg').first().focus();
	});	
	
	$(".widget_replay").click(function() {
		var author = $(this).parents("li").first().find(".emphased").first().text();
		$('#field_msg').text(author + ", ");
		$('#field_msg').first().focus();
	});
});

var m_counter = 1;
function getCounter() {
	m_counter++;
	return m_counter;
}

function bindMainLikeButton() {
	try {
		var retrievedObject = localStorage.getItem(document.referrer + "mainLikeState");
		if(retrievedObject != null && retrievedObject == "1") {
			$("._mainLikeBtn_active").css("display", "none");
			$("._mainLikeBtn_disabled").css("display", "");
			$(".ecnt").text(parseInt($(".ecnt").text())+1);
			$("#smallLikeBtn").removeClass("no-count");
		}
	} catch(e) {console.log(e);}	

	$("._mainLikeBtn_active").click(function() {
		$("._mainLikeBtn_active").css("display", "none");
		$("._mainLikeBtn_disabled").css("display", "");
		$(".ecnt").text(parseInt($(".ecnt").text())+1);
		try {
			localStorage.setItem(document.referrer + "mainLikeState", "1");
		} catch(e) {console.log(e);}
	});
	
	$("._mainLikeBtn_disabled").click(function() {
		$("._mainLikeBtn_disabled").css("display", "none");
		$("._mainLikeBtn_active").css("display", "");
		$(".ecnt").text(parseInt($(".ecnt").text())-1);
		try {
		localStorage.setItem(document.referrer + "mainLikeState", "0");
		} catch(e) {console.log(e);}
	});
	
	$("#smallLikeBtn").click(function() {
		if($(this).hasClass("no-count")) {
			$("._mainLikeBtn_active").css("display", "none");
			$("._mainLikeBtn_disabled").css("display", "");
			$(".ecnt").text(parseInt($(".ecnt").text())+1);
			try {
			localStorage.setItem(document.referrer + "mainLikeState", "1");
			} catch(e) {console.log(e);}			
			$(this).removeClass("no-count");			
		} else {
			$("._mainLikeBtn_disabled").css("display", "none");
			$("._mainLikeBtn_active").css("display", "");
			$(".ecnt").text(parseInt($(".ecnt").text())-1);
			try {
			localStorage.setItem(document.referrer + "mainLikeState", "0");
			} catch(e) {console.log(e);}			
			$(this).addClass("no-count");	
		}
	});	
}

function getFormattedDate() {
	var d = new Date(); 
	var p = new Date(d.getTime() - 0*86400000); 
	var monthA = 'янв,фев,мар,апр,май,июн,июл,авг,сен,окт,ноя,дек'.split(',');
	return p.getDate() + ' ' + monthA[p.getMonth()] + ' ' + p.getHours() + ":" + (p.getMinutes().toString().length == 1 ? "0" + p.getMinutes() : p.getMinutes());
}

function saveAllLikes() {
	var likesArr = [];
	$( ".like-item" ).each(function() {
		if($(this).hasClass("no-like-block")) {
			likesArr.push(0);
		}
		else {
			likesArr.push(1);
		}
	});
	try {	
	localStorage.removeItem(document.referrer + 'likesArr');
	localStorage.setItem(document.referrer + 'likesArr', JSON.stringify(likesArr));
	} catch(e) {console.log(e);}	
}

function loadAllLikes() {
	try {	
	var retrievedObject = localStorage.getItem(document.referrer + 'likesArr');
	if(retrievedObject != null){
		var likes = JSON.parse(retrievedObject);
		$( ".like-item " ).each(function(index) {
			if(likes[index] == "1") {
				$(this).html($("#like_block").html());
				$(this).addClass("like-block").removeClass("no-like-block");
			}
			else {
				$(this).html($("#unlike_block").html());
				$(this).addClass("no-like-block").removeClass("like-block");
			}
		});		
	}
	} catch(e) {console.log(e);}
}

function addCommentToStorage(text, date) {
try {
	var retrievedObject = localStorage.getItem(document.referrer + 'commentsArr');
	if(retrievedObject != null) {
		var comments = JSON.parse(retrievedObject);
		comments = comments + "#####" + text + "#####" + date;
		localStorage.setItem(document.referrer + 'commentsArr', JSON.stringify(comments));
	}
	else {
		localStorage.setItem(document.referrer + 'commentsArr', JSON.stringify(text + "#####" + date));
	}
	$(".total_comments").text($(".like-item").length);
} catch(e) {console.log(e);}	
}

function loadCommentsFromStorage() {
try {
	var retrievedObject = localStorage.getItem(document.referrer + 'commentsArr');
	if(retrievedObject != null) {
		var comments = JSON.parse(retrievedObject).split("#####");
		for(var i=0; i<comments.length-1; i+=2) {
					var newId = "new-comment-item-" + getCounter();
					$("#new-comment-item").clone().css("display", "").attr("id", newId).appendTo("#comments-list");
					
					$("#" + newId + " .divComment").html(comments[i]);
					$("#" + newId + " .divDate").html(comments[i+1]);
		}
	}
	$(".total_comments").text($(".like-item").length-1);
} catch(e) {console.log(e);}	
}

function getCommentDate(delta) {
	d = new Date(); p = new Date(d.getTime() - delta*86400000); 
	monthA = 'янв,фев,мар,апр,мая,июн,июл,авг,сен,окт,ноя,дек'.split(',');
	document.write(p.getDate() + ' ' + monthA[p.getMonth()]); 
}

String.prototype.hashCode = function() {
  var hash = 0, i, chr;
  if (this.length === 0) return hash;
  for (i = 0; i < this.length; i++) {
    chr   = this.charCodeAt(i);
    hash  = ((hash << 5) - hash) + chr;
    hash |= 0; // Convert to 32bit integer
  }
  return hash;
};